From f65d9b308506f66eee10622de7976b66682e26e6 Mon Sep 17 00:00:00 2001
From: Pierangelo Masarati <ando@openldap.org>
Date: Fri, 2 Nov 2001 15:39:43 +0000
Subject: [PATCH] Subtree replication test

---
 tests/data/slapd-repl-submaster.conf |  37 ++++
 tests/data/test-base.ldif            |  16 ++
 tests/scripts/defines.sh             |   2 +
 tests/scripts/test011-subtree-repl   | 253 +++++++++++++++++++++++++++
 4 files changed, 308 insertions(+)
 create mode 100644 tests/data/slapd-repl-submaster.conf
 create mode 100644 tests/data/test-base.ldif
 create mode 100755 tests/scripts/test011-subtree-repl

diff --git a/tests/data/slapd-repl-submaster.conf b/tests/data/slapd-repl-submaster.conf
new file mode 100644
index 0000000000..9836e28c87
--- /dev/null
+++ b/tests/data/slapd-repl-submaster.conf
@@ -0,0 +1,37 @@
+# $OpenLDAP$
+#
+# master slapd config -- for testing of replication
+#
+ucdata-path	./ucdata
+include ./schema/core.schema
+include ./schema/cosine.schema
+include ./schema/inetorgperson.schema
+#
+schemacheck	off
+#
+pidfile     ./test-db/slapd.pid
+argsfile    ./test-db/slapd.args
+
+#######################################################################
+# ldbm database definitions
+#######################################################################
+
+database	@BACKEND@
+cachesize	0
+suffix		"o=University of Michigan, c=US"
+directory	./test-db
+rootdn		"cn=Manager, o=University of Michigan, c=US"
+rootpw		secret
+#ldbm#index		objectClass	eq
+#ldbm#index		cn,sn,uid	pres,eq,sub
+#bdb#index		objectClass	eq
+#bdb#index		cn,sn,uid	pres,eq,sub
+lastmod		on
+
+replogfile	./test-db/slapd.replog
+
+replica		host=localhost:9010
+		suffix="ou=People, o=University of Michigan, c=US"
+		binddn="cn=Replica, o=University of Michigan, c=US"
+		bindmethod=simple
+		credentials=secret
diff --git a/tests/data/test-base.ldif b/tests/data/test-base.ldif
new file mode 100644
index 0000000000..1c551194cd
--- /dev/null
+++ b/tests/data/test-base.ldif
@@ -0,0 +1,16 @@
+dn: o=University of Michigan, c=US
+objectclass: top
+objectclass: organization
+objectclass: domainRelatedObject
+l: Ann Arbor, Michigan
+st: Michigan
+o: University of Michigan
+o: UMICH
+o: UM
+o: U-M
+o: U of M
+description: The University of Michigan at Ann Arbor
+postaladdress: University of Michigan $ 535 W. William St. $ Ann Arbor, MI 481
+ 09 $ US
+telephonenumber: +1 313 764-1817
+associateddomain: umich.edu
diff --git a/tests/scripts/defines.sh b/tests/scripts/defines.sh
index f343e7f4fd..2793900fd2 100755
--- a/tests/scripts/defines.sh
+++ b/tests/scripts/defines.sh
@@ -13,6 +13,7 @@ ACLCONF=$DATADIR/slapd-acl.conf
 MASTERCONF=$DATADIR/slapd-repl-master.conf
 SLAVECONF=$DATADIR/slapd-repl-slave.conf
 REFSLAVECONF=$DATADIR/slapd-ref-slave.conf
+SUBMASTERCONF=$DATADIR/slapd-repl-submaster.conf
 SCHEMACONF=$DATADIR/slapd-schema.conf
 
 DBCONF=$DBDIR/slapd.conf
@@ -52,6 +53,7 @@ MASTERURI="ldap://localhost:$PORT/"
 SLAVEURI="ldap://localhost:$SLAVEPORT/"
 LDIF=$DATADIR/test.ldif
 LDIFORDERED=$DATADIR/test-ordered.ldif
+LDIFBASE=$DATADIR/test-base.ldif
 LDIFPASSWD=$DATADIR/passwd.ldif
 LDIFPASSWDOUT=$DATADIR/passwd-out.ldif
 MONITOR=""
diff --git a/tests/scripts/test011-subtree-repl b/tests/scripts/test011-subtree-repl
new file mode 100755
index 0000000000..84011badcd
--- /dev/null
+++ b/tests/scripts/test011-subtree-repl
@@ -0,0 +1,253 @@
+#! /bin/sh
+# $OpenLDAP$
+
+SRCDIR="."
+if test $# -ge 1 ; then
+	SRCDIR=$1; shift
+fi
+BACKEND=ldbm
+if test $# -ge 1 ; then
+	BACKEND=$1; shift
+fi
+WAIT=0
+if test $# -ge 1 ; then
+	WAIT=1; shift
+fi
+
+echo "running defines.sh"
+. $SRCDIR/scripts/defines.sh
+
+#
+# Test replication:
+# - start master
+# - start slave
+# - create root entry in slave
+# - start slurpd
+# - populate over ldap
+# - perform some modifies and deleted
+# - retrieve database over ldap and compare against expected results
+#
+
+if test ! -x $SLURPD ; then
+	echo ">>>>> $SLURPD is not executable or do not exist."
+	echo ">>>>> Test skipped."
+	exit 0
+fi
+
+echo "Cleaning up in $DBDIR..."
+rm -f $DBDIR/[!C]*
+echo "Cleaning up in $REPLDIR..."
+rm -f $REPLDIR/[!C]*
+
+echo "Starting master slapd on TCP/IP port $PORT..."
+. $CONFFILTER $BACKEND < $SUBMASTERCONF > $DBCONF
+$SLAPD -f $DBCONF -h $MASTERURI -d $LVL $TIMING > $MASTERLOG 2>&1 &
+PID=$!
+if test $WAIT != 0 ; then
+    echo PID $PID
+    read foo
+fi
+
+echo "Starting slave slapd on TCP/IP port $SLAVEPORT..."
+. $CONFFILTER $BACKEND < $SLAVECONF > $REPLCONF
+$SLAPD -f $REPLCONF -h $SLAVEURI -d $LVL $TIMING > $SLAVELOG 2>&1 &
+SLAVEPID=$!
+if test $WAIT != 0 ; then
+    echo SLAVEPID $SLAVEPID
+    read foo
+fi
+
+echo "Using ldapsearch to check that master slapd is running..."
+for i in 0 1 2 3 4 5; do
+	$LDAPSEARCH -s base -b "$MONITOR" -h localhost -p $PORT \
+		'objectclass=*' > /dev/null 2>&1
+	RC=$?
+	if test $RC = 1 ; then
+		echo "Waiting 5 seconds for slapd to start..."
+		sleep 5
+	fi
+done
+
+echo "Using ldapsearch to check that slave slapd is running..."
+for i in 0 1 2 3 4 5; do
+	$LDAPSEARCH -s base -b "$MONITOR" -h localhost -p $PORT \
+		'objectclass=*' > /dev/null 2>&1
+	RC=$?
+	if test $RC = 1 ; then
+		echo "Waiting 5 seconds for slapd to start..."
+		sleep 5
+	fi
+done
+
+echo "Creating base in subtree slave"
+$LDAPADD -D "$UPDATEDN" -h localhost -p $SLAVEPORT -w $PASSWD < \
+	$LDIFBASE > /dev/null 2>&1
+RC=$?
+if test $RC != 0 ; then
+	echo "ldapadd failed ($RC)!"
+	kill -INT $PID $SLAVEPID
+	kill -KILL $SLURPPID
+	exit $RC
+fi
+
+echo "Starting slurpd..."
+$SLURPD -f $SUBMASTERCONF -d ${SLURPD_DEBUG-5} -t $REPLDIR > $SLURPLOG 2>&1 &
+SLURPPID=$!
+
+echo "Using ldapadd to populate the master directory..."
+$LDAPADD -D "$MANAGERDN" -h localhost -p $PORT -w $PASSWD < \
+	$LDIFORDERED > /dev/null 2>&1
+RC=$?
+if test $RC != 0 ; then
+	echo "ldapadd failed ($RC)!"
+	kill -INT $PID $SLAVEPID
+	kill -KILL $SLURPPID
+	exit $RC
+fi
+
+echo "Waiting 15 seconds for slurpd to send changes..."
+sleep 15
+
+echo "Using ldapmodify to modify master directory..."
+
+#
+# Do some modifications
+#
+
+$LDAPMODIFY -v -D "$MANAGERDN" -h localhost -p $PORT -w $PASSWD > \
+	$TESTOUT 2>&1 << EOMODS
+dn: cn=James A Jones 1, ou=Alumni Association, ou=People, o=University of Michigan, c=US
+changetype: modify
+add: drink
+drink: Orange Juice
+
+dn: cn=Bjorn Jensen, ou=Information Technology Division, ou=People, o=University of Michigan, c=US
+changetype: modify
+replace: drink
+drink: Iced Tea
+drink: Mad Dog 20/20
+
+dn: cn=ITD Staff,ou=Groups,o=University of Michigan,c=US
+delete: member
+member: cn=James A Jones 2, ou=Information Technology Division, ou=People, o=University of Michigan, c=US
+member: cn=Bjorn Jensen, ou=Information Technology Division, ou=People, o=University of Michigan, c=US
+-
+add: member
+member: cn=Dorothy Stevens, ou=Alumni Association, ou=People, o=University of Michigan, c=US
+member: cn=James A Jones 1, ou=Alumni Association, ou=People, o=University of Michigan, c=US
+
+dn: cn=All Staff,ou=Groups,o=University of Michigan,c=US
+changetype: modify
+delete: member
+
+dn: cn=Gern Jensen, ou=Information Technology Division, ou=People, o=University of Michigan, c=US
+changetype: add
+objectclass: top
+objectclass: person
+objectclass: organizationalPerson
+objectclass: newPilotPerson
+cn: Gern Jensen
+sn: Jensen
+title: Chief Investigator, ITD
+postaladdress: ITD $ 535 W. William St $ Ann Arbor, MI 48103
+seealso: cn=All Staff, ou=Groups, o=University of Michigan, c=US
+drink: Coffee
+homepostaladdress: 844 Brown St. Apt. 4 $ Ann Arbor, MI 48104
+description: Very odd
+facsimiletelephonenumber: +1 313 555 7557
+telephonenumber: +1 313 555 8343
+mail: gjensen@mailgw.umich.edu
+homephone: +1 313 555 8844
+
+dn: ou=Retired, ou=People, o=University of Michigan, c=US
+changetype: add
+objectclass: top
+objectclass: organizationalUnit
+ou: Retired
+
+dn: cn=Rosco P. Coltrane, ou=Information Technology Division, ou=People, o=University of Michigan, c=US
+changetype: add
+objectclass: top
+objectclass: person
+cn: Rosco P. Coltrane
+sn: Coltrane
+
+dn: cn=Rosco P. Coltrane, ou=Information Technology Division, ou=People, o=University of Michigan, c=US
+changetype: modrdn
+newrdn: cn=Rosco P. Coltrane
+deleteoldrdn: 1
+newsuperior: ou=Retired, ou=People, o=University of Michigan, c=US
+
+dn: cn=James A Jones 2, ou=Information Technology Division, ou=People, o=University of Michigan, c=US
+changetype: delete
+
+EOMODS
+
+echo "Waiting 15 seconds for slurpd to send changes..."
+sleep 15
+
+echo "Using ldapsearch to read the subtree entries from the master..."
+$LDAPSEARCH -S "" -b "$BASEDN" -s base -h localhost -p $PORT \
+	'objectclass=*' > $MASTEROUT 2>&1
+
+if test $RC != 0 ; then
+	echo "ldapsearch failed ($RC)!"
+	kill -INT $PID $SLAVEPID
+	kill -KILL $SLURPPID
+	exit $RC
+fi
+
+$LDAPSEARCH -S "" -b "ou=People, $BASEDN" -h localhost -p $PORT \
+	'objectclass=*' >> $MASTEROUT 2>&1
+
+if test $RC != 0 ; then
+	echo "ldapsearch failed ($RC)!"
+	kill -INT $PID $SLAVEPID
+	kill -KILL $SLURPPID
+	exit $RC
+fi
+
+echo "Using ldapsearch to read all the entries from the slave..."
+$LDAPSEARCH -S "" -b "$BASEDN" -s base -h localhost -p $SLAVEPORT \
+	'objectclass=*' > $SLAVEOUT 2>&1
+
+if test $RC != 0 ; then
+	echo "ldapsearch failed ($RC)!"
+	kill -INT $PID $SLAVEPID
+	kill -KILL $SLURPPID
+	exit $RC
+fi
+
+$LDAPSEARCH -S "" -b "ou=People, $BASEDN" -h localhost -p $SLAVEPORT \
+	'objectclass=*' >> $SLAVEOUT 2>&1
+
+if test $RC != 0 ; then
+	echo "ldapsearch failed ($RC)!"
+	kill -INT $PID $SLAVEPID
+	kill -KILL $SLURPPID
+	exit $RC
+fi
+
+kill -INT $PID $SLAVEPID
+kill -KILL $SLURPPID
+
+SEARCHOUT=$MASTEROUT
+LDIF=$SLAVEOUT
+
+echo "Filtering ldapsearch results..."
+. $LDIFFILTER < $SEARCHOUT > $SEARCHFLT
+echo "Filtering original ldif used to create database..."
+. $LDIFFILTER < $LDIF > $LDIFFLT
+
+echo "Comparing retrieved entries from master and slave..."
+$CMP $SEARCHFLT $LDIFFLT > $CMPOUT
+
+if test $? != 0 ; then
+	echo "test failed - master and slave databases differ"
+	exit 1
+fi
+
+echo ">>>>> Test succeeded"
+
+
+exit 0
-- 
GitLab